//+------------------------------------------------------------------+
//|                                                      T101_VininE |
//|                                Copyright  2008, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"


#include <WinUser32.mqh>


extern bool    CheckNevBar    = false;
extern int     ShiftBack      =   8;
extern int     CorrelationBar =  27;
extern string  ListSymbol     = "AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURJPY,EURGBP,EURNZD,EURUSD,NZDUSD,NZDJPY,GBPUSD,GBPCHF,GBPJPY,USDCHF,USDJPY,USDCAD";
extern int     StopLoss       = 100;
extern int     TakeProfit     = 100;

extern int reversi=-1;


extern int Magic=20081018;
extern int pos=1;

double Lot=0;

string   WorkSymbol[];
int      WorkOp[];
double   WorkPips[];
int      WorkSort[];
int      WorkCorr[];
int      WorkTicket[];

int      WorkCount;

int Order_Count[6];
string   NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};


int week_back;
int shift=0;
int WorkPrevTime=0;
int Ind_Base=-1;

int init() {
   WorkCount=0;
   ArrayResize(WorkSymbol,100);
   int i1=0,i2=0;
   i2=StringFind(ListSymbol,",",i1);
   while (i2>0) {
      WorkSymbol[WorkCount]=StringSubstr(ListSymbol,i1,i2-i1);
      WorkCount++;
      i1=i2+1;
      i2=StringFind(ListSymbol,",",i1+1);
   }
   WorkSymbol[WorkCount]=StringSubstr(ListSymbol,i1);
   WorkCount++;
   ArrayResize(WorkSymbol, WorkCount);
   ArrayResize(WorkOp,     WorkCount);
   ArrayResize(WorkPips,   WorkCount);
   ArrayResize(WorkSort,   WorkCount);
   ArrayResize(WorkCorr,   WorkCount);
   ArrayResize(WorkTicket, WorkCount);

   ArrayInitialize(WorkOp,-1);
   ArrayInitialize(WorkSort,-1);
   ArrayInitialize(WorkCorr,0);
   ArrayInitialize(WorkTicket,-1);
   
  
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
  }


int start() {
   int err=GetLastError();
   if (CheckNevBar) if (!WorkNevBar()) return(0);
   if (Lot==0) Lot=MarketInfo(Symbol(),MODE_MINLOT);
   check_order();
   run_statistics();  
   run_sort();
   run_correlation(WorkSort[0]);
   run_trade();
   err=GetLastError();
   if (err>0) Print(err);

   return(0);
}

void check_order(){
   ArrayInitialize(WorkTicket,-1);
   for (int i=0;i<OrdersTotal();i++){
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      for (int j=0;j<WorkCount;j++) {
         if (OrderSymbol()==WorkSymbol[j]){
            WorkTicket[j]=OrderTicket();
            break;
         }
      }
   }
}

void run_statistics() {
   for (int i=0;i<14;i++) WorkPips[i] = CalculatePips(WorkSymbol[i]);
}

void run_correlation(int Base){
   int err=GetLastError();
   double sx, sy, dx, dy,dxy,sb, co, sdxy;
   
   sx=iMA(WorkSymbol[Base],0,CorrelationBar,0,MODE_SMA,PRICE_CLOSE,pos);
   dx=0;
   for (int i=0; i<CorrelationBar; i++)  
      dx+=MathPow(iClose(WorkSymbol[Base],0,pos+i)-sx,2);
   for (int j=0;j<WorkCount;j++) {
      if (Base==j) {WorkCorr[j]=reversi;}
      else {
         sy=iMA(WorkSymbol[j],0,CorrelationBar,0,MODE_SMA,PRICE_CLOSE,pos);
         dy=0;
         dxy=0;
         for (i=0; i<CorrelationBar; i++)  {
            dy+=MathPow(iClose(WorkSymbol[j],0,pos+i)-sy,2);
            dxy+=(iClose(WorkSymbol[Base],0,pos+i)-sy)*(iClose(WorkSymbol[j],0,pos+i)-sy);
         }
         sdxy=MathSqrt(dx*dy);
         WorkCorr[j]=0;
         if (sdxy!=0) {
            dxy/=sdxy;
            if (dxy> 0.7) WorkCorr[j]= reversi;
            if (dxy<-0.7) WorkCorr[j]=-reversi;
         }         
      }
   }
   err=GetLastError();
   if (err>0) Print(err);

}


double CalculatePips(string Sym){
   int err=GetLastError();
   double _Point, m, m_now,m_pips;
   if (StringLen(Sym)==0)  return(0);
   double TickValue=MarketInfo(Sym,MODE_TICKVALUE);
   _Point=dPoint(Sym);
   if (_Point==0) return(0);
   m_pips = (iClose(Sym, 0, 0)-iOpen(Sym, 0, ShiftBack))/_Point;//*TickValue;
   err=GetLastError();
   if (err>0) Print(err);
   return(m_pips);
}



void run_sort(){
   int    tmp;
   
   for (int i=0;i<WorkCount;i++) WorkSort[i]=i;
   
   for(i=0;i < WorkCount;i++)    {
		for(int j=i+1;j<WorkCount;j++) {
			if(WorkPips[WorkSort[i]] < WorkPips[WorkSort[j]])  {
				tmp = WorkSort[j]; 
				WorkSort[j] = WorkSort[i]; 
				WorkSort[i] = tmp;
			}
		}
	}
}



bool analyze_trades() {
   int i, sp,sm;
   sp=0;
   sm=0;
   for (i=0;i<WorkCount;i++) {
      if (WorkCorr[WorkSort[i]]==1) {      
         if (WorkPips[WorkSort[i]]>0) sm++;
         sp++;
      }
   }
   if (sp==0 || sp!=sm) return(true);
   return(false);
}

void run_trade(){
   //  
   for (int i=0;i<WorkCount;i++) {
      if (WorkTicket[i]==-1) continue;
      OrderSelect(WorkTicket[i],SELECT_BY_TICKET);
      if (OrderCloseTime()>0) WorkTicket[i]=-1;
      else {
         if (WorkCorr[i]== 0)                          {Order_Close(WorkSymbol[i],Magic);          WorkTicket[i]=-1;}
         if (WorkCorr[i]== 1 && OrderType()==OP_SELL)  {Order_Close(WorkSymbol[i],Magic,OP_SELL);  WorkTicket[i]=-1;}
         if (WorkCorr[i]==-1 && OrderType()==OP_BUY )  {Order_Close(WorkSymbol[i],Magic,OP_BUY );  WorkTicket[i]=-1;}
      }
   }
   for (i=0;i<WorkCount;i++) {
      if (WorkTicket[i]>=0 || WorkCorr[i]== 0) continue;
      if (WorkCorr[i]== 1) WorkTicket[i]=Order_Open(WorkSymbol[i],Magic,OP_BUY); 
      else WorkTicket[i]=Order_Open(WorkSymbol[i],Magic,OP_SELL);
   }
}




double dPoint(string sym) {
   double _Point = MarketInfo(sym, MODE_POINT);
   if (StringFind(sym, "JPY")>=0) _Point=0.01;
   if (_Point==0) _Point=0.0001; 
   return (_Point);
}

bool WorkNevBar(){
   int NevTime=Time[0];
   if (WorkPrevTime==NevTime) return(false);
   WorkPrevTime=NevTime;
   return(true);
}


//======================================================================================================
//   
//=====================================================================================================
double iif(bool A, double B, double C) {if(A) return(B); return(C); }

//======================================================================================================
//   
//=====================================================================================================
int Order_Open(string Sym, int Magic, int OP){
   int err=GetLastError();
   if (!CheckSymbol(Sym)) return(-1);
   RefreshRates();

   int cmd=iif(OP==OP_BUY,1,-1);
   double _ask     =MarketInfo(Sym,MODE_ASK);
   double _bid     =MarketInfo(Sym,MODE_BID);
   double _point   =MarketInfo(Sym,MODE_POINT);
   double _digits  =MarketInfo(Sym,MODE_DIGITS);
   double price= iif(OP==OP_BUY,_ask,_bid);
   double _sl=NormalizeDouble(iif(StopLoss==0,0,price-cmd*StopLoss*_point),_digits);
   double _tp=NormalizeDouble(iif(TakeProfit==0,0,price+cmd*TakeProfit*_point),_digits);
   string _comment=WorkSymbol[WorkSort[0]];
   int ticket=OrderSend(Sym, OP,  Lot, price, 15,_sl,_tp,_comment,Magic, 0); 
   err=GetLastError();
   if (err>0) {
      if (err==129) Print("Order Open error=",err,": ",Sym,", ", price,", ",_ask,", ",_bid,", ",iClose(Sym,0,0));
      else Print("Order Open error=",err,": ",Sym,", ", OP,", ",  Lot,", ", price,", ", _sl,", ",_tp,", ",_comment);
   }
   return(ticket);
}
void Order_Close(string WorkSymbol, int Magic, int OP=-1){
   bool res;
   GetLastError();
   for(int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderMagicNumber() != Magic)                   continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      
      RefreshRates();
      
      double _ask      =MarketInfo(OrderSymbol(),MODE_ASK);
      double  _bid     =MarketInfo(OrderSymbol(),MODE_BID);
      double  _point   =MarketInfo(OrderSymbol(),MODE_POINT);
      double  _digits  =MarketInfo(OrderSymbol(),MODE_DIGITS);
      double ClosePrice=NormalizeDouble(iif(OrderType()==OP_BUY,_bid, _ask),_digits);
      res=OrderClose(OrderTicket(), OrderLots(), ClosePrice, 3);
   }
}

//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(string WorkSymbol, int Magic, int OP=-1){
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != WorkSymbol)                   continue;
      if (OrderMagicNumber() != Magic)                   continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      Order_Count[OrderType()]++;
   }
   if (OP!=-1) return(Order_Count[OP]);
}

bool CheckSymbol(string WorkSymbol) {
   if ((IsTesting() || IsOptimization()) && WorkSymbol!=Symbol()) return(false);
   return(true);
}


